﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.Objects;
using System.Data.EntityClient;

namespace AssociationMany2Many
{
    public partial class BibliotekaEntities : ObjectContext
    {
        public BibliotekaEntities() :
            base("name=BibliotekaEntities", "BibliotekaEntities")
        {
            this.OnContextCreated();
        }
        public BibliotekaEntities(string connectionString) :
            base(connectionString, "BibliotekaEntities")
        {
            this.OnContextCreated();
        }
        public BibliotekaEntities(EntityConnection connection) :
            base(connection, "BibliotekaEntities")
        {
            this.OnContextCreated();
        }
        partial void OnContextCreated();
        public ObjectQuery<Ksiazka> Ksiazka
        {
            get
            {
                if ((this._Ksiazka == null))
                {
                    this._Ksiazka = base.CreateQuery<Ksiazka>("[Ksiazka]");
                }
                return this._Ksiazka;
            }
        }
        private ObjectQuery<Ksiazka> _Ksiazka;
        public ObjectQuery<Kategoria> Kategoria
        {
            get
            {
                if ((this._Kategoria == null))
                {
                    this._Kategoria = base.CreateQuery<Kategoria>("[Kategoria]");
                }
                return this._Kategoria;
            }
        }
        private ObjectQuery<Kategoria> _Kategoria;
        public void AddToKsiazka(Ksiazka ksiazka)
        {
            base.AddObject("Ksiazka", ksiazka);
        }
        public void AddToKategoria(Kategoria kategoria)
        {
            base.AddObject("Kategoria", kategoria);
        }
    }
    class Program
    {
        static void Main(string[] args)
        {
            var context = new BibliotekaEntities();

            var kat1 = new Kategoria { ID = 1, Nazwa = "KAT1" };
            var kat2 = new Kategoria { ID = 2, Nazwa = "KAT2" };
            var ks1 = new Ksiazka { ID = 1, Autor = "A1", Tytul = "T1" };
            var ks2 = new Ksiazka { ID = 2, Autor = "A2", Tytul = "T2" };
            var ks3 = new Ksiazka { ID = 3, Autor = "A3", Tytul = "T3" };

            kat1.K_Ksiazka.Add(ks1); kat1.K_Ksiazka.Add(ks2);
            kat2.K_Ksiazka.Add(ks2); kat2.K_Ksiazka.Add(ks3);

            //context.AddToKategoria(kat1);
            //context.AddToKategoria(kat2);
            context.AddToKsiazka(ks1);
            context.AddToKsiazka(ks2);
            context.AddToKsiazka(ks3);

            context.SaveChanges();

            context.DeleteObject( ks2 );
            context.SaveChanges();
        }
    }
}
