﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.Objects;
using System.Data.EntityClient;

namespace AssociationOne2Many
{
    public partial class BibliotekaEntities : ObjectContext
    {
        public BibliotekaEntities() :
            base( "name=BibliotekaEntities", "BibliotekaEntities" )
        {
            this.OnContextCreated();
        }
        public BibliotekaEntities( string connectionString ) :
            base( connectionString, "BibliotekaEntities" )
        {
            this.OnContextCreated();
        }
        public BibliotekaEntities( EntityConnection connection ) :
            base( connection, "BibliotekaEntities" )
        {
            this.OnContextCreated();
        }
        partial void OnContextCreated();
        public ObjectQuery<Ksiazka> Ksiazka
        {
            get
            {
                if ( ( this._Ksiazka == null ) )
                {
                    this._Ksiazka = base.CreateQuery<Ksiazka>( "[Ksiazka]" );
                }
                return this._Ksiazka;
            }
        }
        private ObjectQuery<Ksiazka> _Ksiazka;
        public ObjectQuery<Egzemplarz> Egzemplarz
        {
            get
            {
                if ( ( this._Egzemplarz == null ) )
                {
                    this._Egzemplarz = base.CreateQuery<Egzemplarz>( "[Egzemplarz]" );
                }
                return this._Egzemplarz;
            }
        }
        private ObjectQuery<Egzemplarz> _Egzemplarz;
        public void AddToKsiazka( Ksiazka ksiazka )
        {
            base.AddObject( "Ksiazka", ksiazka );
        }
        public void AddToEgzemplarz( Egzemplarz egzemplarz )
        {
            base.AddObject( "Egzemplarz", egzemplarz );
        }
    }
    class Program
    {
        static void Main( string[] args )
        {
            BibliotekaEntities context = new BibliotekaEntities();

            var k1 = new Ksiazka { ID = 1, Autor = "A1", Tytul = "T1" };
            var e1 = new Egzemplarz { ID = 1, Sygnatura = "123456" };
            var e2 = new Egzemplarz { ID = 2, Sygnatura = "654321" };

            k1.K_Egzemplarz.Add( e1 ); k1.K_Egzemplarz.Add( e2 );
            //e1.Ksiazka = k1; e2.Ksiazka = k1;

            //context.AddToKsiazka( k1 );
            context.AddToEgzemplarz( e1 );
            context.AddToEgzemplarz( e2 );
            context.SaveChanges();

            BibliotekaEntities context2 = new BibliotekaEntities();
            var b = context2.Ksiazka.First().K_Egzemplarz.IsLoaded;
            Console.WriteLine( context2.Ksiazka.First().K_Egzemplarz.Count() );
            context2.Ksiazka.First().K_Egzemplarz.Load();
            Console.WriteLine( context2.Ksiazka.First().K_Egzemplarz.Count() );

            var list =
                from k in context2.Ksiazka
                where k.K_Egzemplarz.Any(x => x.Sygnatura == "123456")
                select k;

            foreach (var c in list)
                Console.WriteLine(c.Tytul);

            BibliotekaEntities context3 = new BibliotekaEntities();
            context3.Egzemplarz.First().KsiazkaReference.Load();
            Console.WriteLine( context3.Egzemplarz.First().Ksiazka.Autor );

            //context.DeleteObject( list.First() );
            context2.DeleteObject( context2.CreateQuery<Egzemplarz>( "[Egzemplarz]" ).First() );
            context2.SaveChanges();
        }
    }
}
