﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.Objects;
using System.Data.Objects.DataClasses;

[assembly: EdmSchemaAttribute()]

namespace Inheritance2
{
    public partial class Entities : ObjectContext
    {
        public Entities() : base( "name=Entities", "Entities" ) { }
        public ObjectQuery<Osoba> Osoba
        {
            get
            {
                if ( ( this._Osoba == null ) )
                {
                    this._Osoba = base.CreateQuery<Osoba>( "[Osoba]" );
                }
                return this._Osoba;
            }
        }
        private ObjectQuery<Osoba> _Osoba;
        public void AddToOsoba( Osoba osoba )
        {
            base.AddObject( "Osoba", osoba );
        }
    }
    class Program
    {
        static void Main( string[] args )
        {
            var context = new Entities();

            var o1 = new Osoba { ID = 1, Imie = "J01", Nazwisko = "K01" };
            var o2 = new Pracownik { ID = 2, Imie = "J02", Nazwisko = "K02", Pensja = 10 };
            var o3 = new Nauczyciel { ID = 3, Imie = "J03", Nazwisko = "K03", Pensja = 5, Staz = 20 };

            context.AddToOsoba( o1 );
            context.AddToOsoba( o2 );
            context.AddToOsoba( o3 );
            context.SaveChanges();

            var list =
                from o in context.CreateQuery<Osoba>( "[Osoba]" ).OfType<Pracownik>()
                select o;

            foreach ( var x in list )
                Console.WriteLine( x.Nazwisko );
        }
    }
}
