﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.Objects;
using Model;

namespace Inheritance3
{
    public partial class Entities : ObjectContext
    {
        public Entities() : base( "name=Entities", "Entities" ) { }
        public ObjectQuery<Ksiazka> Ksiazka
        {
            get
            {
                if ( ( this._Ksiazka == null ) )
                {
                    this._Ksiazka = base.CreateQuery<Ksiazka>( "[Ksiazka]" );
                }
                return this._Ksiazka;
            }
        }
        private ObjectQuery<Ksiazka> _Ksiazka;
        public void AddToKsiazka( Ksiazka Ksiazka )
        {
            base.AddObject( "Ksiazka", Ksiazka );
        }
    }
    class Program
    {
        static void Main( string[] args )
        {
            var context = new Entities();

            var ks = new Ksiazka { ID = 1, Autor = "A01", Tytul = "T01" };
            var kat = new Katalog { ID = 2, Autor = "A02", Tytul = "T02", Rok = 2009 };
            var pod = new Podrecznik { ID = 3, Autor = "A03", Tytul = "T03", Klasa = 5 };

            context.AddToKsiazka( ks );
            context.AddToKsiazka( kat );
            context.AddToKsiazka( pod );
            context.SaveChanges();

            var list =
                from k in context.Ksiazka//.OfType<Pracownik>()
                select k;

            foreach ( var x in list )
                Console.WriteLine( x.Tytul );
        }
    }
}
