﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.Objects;
using Model;
using System.Data.EntityClient;

namespace SpeedTest1
{
    public partial class BibliotekaEntities : ObjectContext
    {
        public BibliotekaEntities() :
            base( "name=BibliotekaEntities", "BibliotekaEntities" )
        {
            this.OnContextCreated();
        }
        public BibliotekaEntities( string connectionString ) :
            base( connectionString, "BibliotekaEntities" )
        {
            this.OnContextCreated();
        }
        public BibliotekaEntities( EntityConnection connection ) :
            base( connection, "BibliotekaEntities" )
        {
            this.OnContextCreated();
        }
        partial void OnContextCreated();
        public ObjectQuery<Ksiazka> Ksiazka
        {
            get
            {
                if ( ( this._Ksiazka == null ) )
                {
                    this._Ksiazka = base.CreateQuery<Ksiazka>( "[Ksiazka]" );
                }
                return this._Ksiazka;
            }
        }
        private ObjectQuery<Ksiazka> _Ksiazka;
        public ObjectQuery<Egzemplarz> Egzemplarz
        {
            get
            {
                if ( ( this._Egzemplarz == null ) )
                {
                    this._Egzemplarz = base.CreateQuery<Egzemplarz>( "[Egzemplarz]" );
                }
                return this._Egzemplarz;
            }
        }
        private ObjectQuery<Egzemplarz> _Egzemplarz;
        public void AddToKsiazka( Ksiazka ksiazka )
        {
            base.AddObject( "Ksiazka", ksiazka );
        }
        public void AddToEgzemplarz( Egzemplarz egzemplarz )
        {
            base.AddObject( "Egzemplarz", egzemplarz );
        }
    }
    class Program
    {
        static void Main( string[] args )
        {
            // 0. Test tworzenia sesji
            //{
            //    Console.WriteLine( DateTime.Now );
            //    //BibliotekaEntities context = new BibliotekaEntities();
            //    for ( int i=0; i<1000; ++i )
            //    {
            //        BibliotekaEntities context = new BibliotekaEntities();
            //        var k = new Ksiazka { ID = i, Autor = "A"+i.ToString(), Tytul = "T"+i.ToString() };
            //        context.AddToKsiazka( k );
            //        context.SaveChanges();
            //    }
            //    Console.WriteLine( DateTime.Now );
            //}

            // 1. Test zapisywanie obiektów
            //{
            //    DateTime start = DateTime.Now;
            //    BibliotekaEntities context = new BibliotekaEntities();
            //    int count = 0;
            //    for ( int i=0; i<5000; ++i )
            //    {
            //        var k = new Ksiazka { ID = i, Autor = "A"+i.ToString(), Tytul = "T"+i.ToString() };
            //        context.AddToKsiazka( k );
            //        for ( int j=0; j<20; ++j, ++count )
            //        {
            //            var e = new Egzemplarz { ID = count, Sygnatura = "S-"+i.ToString()+"-"+j.ToString() };
            //            context.AddToEgzemplarz( e );
            //            //k.K_Egzemplarz.Add( e );
            //            e.Ksiazka = k;
            //            // Bez znaczenia dla szybkości, który sposób określenia asocjacji się wybierze
            //        }
            //    }
            //    context.SaveChanges();
            //    DateTime stop = DateTime.Now;
            //    Console.WriteLine( ( stop - start ).TotalMilliseconds.ToString() );
            //}

            // 2. Wyciąganie danych
            //{
            //    double[] czasy = new double[10];
            //    for ( int x = 0; x<10; x++ )
            //    {
            //        DateTime start = DateTime.Now;
            //        BibliotekaEntities context = new BibliotekaEntities();

            //        var list =
            //        from k in context.Ksiazka
            //        join e in context.Egzemplarz on k.ID equals e.Ksiazka.ID
            //        select new { k, e };

            //        int liczba = 0;
            //        foreach ( var c in list )
            //            if ( c.e.Sygnatura.EndsWith( "5" ) )
            //                ++liczba;

            //        //Console.WriteLine( liczba.ToString() );
            //        DateTime stop = DateTime.Now;
            //        czasy[x] = ( stop - start ).TotalMilliseconds;
            //    }
            //    Console.WriteLine( czasy.Sum()/10 );
            //}

            {
                double[] czasy1 = new double[10];
                double[] czasy2 = new double[10];
                for ( int x = 0; x<1; x++ )
                {
                    BibliotekaEntities context = new BibliotekaEntities();

                    DateTime t1 = DateTime.Now;

                    //var list =
                    //    from k in context.Ksiazka
                    //    join e in context.Egzemplarz on k.ID equals e.Ksiazka.ID
                    //    select new { k, e };

                            //int liczba = 0;
                            //foreach ( var c in list )
                            //    if ( c.e.Sygnatura.EndsWith( "5" ) )
                            //        ++liczba;

                    DateTime t2 = DateTime.Now;
                    var list =
                        from k in context.Ksiazka
                        join e in context.Egzemplarz on k.ID equals e.Ksiazka.ID
                        select new { k, e };

                    foreach ( var c in list )
                        if ( c.e.Sygnatura.EndsWith( "5" ) )
                        {
                            c.e.Status++;
                        }

                    context.SaveChanges();
                    DateTime t3 = DateTime.Now;

                    czasy1[x] = ( t2 - t1 ).TotalMilliseconds;
                    czasy2[x] = ( t3 - t2 ).TotalMilliseconds;
                }
                Console.WriteLine( czasy1.Sum()/1 );
                Console.WriteLine( czasy2.Sum()/1 );
            }


        }
    }
}
