﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DevExpress.Xpo;
using System.Configuration;

namespace SpeedTest2
{
    [Persistent( "XPEgzemplarz" )]
    public class Egzemplarz : XPLiteObject
    {
        public Egzemplarz( Session Session ) : base( Session ) { }

        [Key]
        public int ID { get; set; }

        public string Sygnatura { get; set; }

        private int status;
        public int Status
        {
            get { return status; }
            set
            {
                int oldValue = Status;
                if ( oldValue == value ) return;
                status = value;
                OnChanged( "Status", oldValue, value );
            }
        }


        [Persistent( "Ksiazka_ID" ), Association( "Egzemplarz_Ksiazka" )]
        public Ksiazka Ksiazka { get; set; }
    }
    [Persistent( "XPKsiazka" )]
    public class Ksiazka : XPLiteObject
    {
        public Ksiazka( Session Session ) : base( Session ) { }

        [Key]
        public int ID { get; set; }

        public string Autor { get; set; }

        public string Tytul { get; set; }

        [Association( "Egzemplarz_Ksiazka", typeof( Egzemplarz ) )]
        public XPCollection<Egzemplarz> K_Egzemplarz
        {
            get { return GetCollection<Egzemplarz>( "K_Egzemplarz" ); }
        }
    }

    class Program
    {
        static void Main( string[] args )
        {
            XpoDefault.ConnectionString = ConfigurationManager.AppSettings["ConnectionString"];

            //XPQuery<Ksiazka> ksiazka = new XPQuery<Ksiazka>( Session.DefaultSession );
            //XPQuery<Egzemplarz> egzemplarz = new XPQuery<Egzemplarz>( Session.DefaultSession );

            // 1. Tworzenie obiektów
            //{
            //    DateTime start = DateTime.Now;
            //    int count = 0;
            //    for ( int i=0; i<5000; ++i )
            //    {
            //        var k = new Ksiazka( Session.DefaultSession ) { ID = i, Autor = "A"+i.ToString(), Tytul = "T"+i.ToString() };
            //        k.Save();
            //        for ( int j=0; j<20; ++j, ++count )
            //        {
            //            var e = new Egzemplarz( Session.DefaultSession ) { ID = count, Sygnatura = "S-"+i.ToString()+"-"+j.ToString() };
            //            e.Ksiazka = k;
            //            e.Save();
            //        }
            //    }
            //    DateTime stop = DateTime.Now;
            //    Console.WriteLine( ( stop - start ).TotalMilliseconds.ToString() );
            //}

            // 1a. Test zapisywania obiektów (UoW)
            //{
            //    using ( UnitOfWork uow = new UnitOfWork() )
            //    {
            //        uow.ConnectionString = ConfigurationManager.AppSettings["ConnectionString"];

            //        DateTime start = DateTime.Now;
            //        int count = 0;
            //        for ( int i=0; i<5000; ++i )
            //        {
            //            var k = new Ksiazka( uow ) { ID = i, Autor = "A"+i.ToString(), Tytul = "T"+i.ToString() };
            //            k.Save();
            //            for ( int j=0; j<20; ++j, ++count )
            //            {
            //                var e = new Egzemplarz( uow ) { ID = count, Sygnatura = "S-"+i.ToString()+"-"+j.ToString() };
            //                e.Ksiazka = k;
            //                e.Save();
            //            }
            //        }
            //        uow.CommitChanges();
            //        DateTime stop = DateTime.Now;
            //        Console.WriteLine( ( stop - start ).TotalMilliseconds.ToString() );
            //    }
            //}

            // 2. Wyciąganie danych
            //{
            //    double[] czasy = new double[10];
            //    for ( int x = 0; x<10; x++ )
            //    {
            //        DateTime start = DateTime.Now;

            //        int liczba = 0;
            //        foreach ( var c in egzemplarz )
            //            if ( c.Sygnatura.EndsWith( "5" ) )
            //                ++liczba;

            //        //Console.WriteLine( liczba.ToString() );
            //        DateTime stop = DateTime.Now;
            //        czasy[x] = ( stop - start ).TotalMilliseconds;
            //    }
            //    Console.WriteLine( czasy.Sum()/10 );
            //}



            //{
            //    double[] czasy1 = new double[1];
            //    double[] czasy2 = new double[1];
            //    for ( int x = 0; x<1; x++ )
            //    {
            //        DateTime t1 = DateTime.Now;

            //        //int liczba = 0;
            //        //foreach ( var c in egzemplarz )
            //        //    if ( c.Ksiazka.Autor.EndsWith( "5" ) )
            //        //        ++liczba;

            //        DateTime t2 = DateTime.Now;

            //        foreach ( var c in egzemplarz )
            //            if ( c.Sygnatura.EndsWith( "5" ) )
            //            {
            //                c.Status++;
            //                c.Save();
            //            }

            //        DateTime t3 = DateTime.Now;

            //        czasy1[x] = ( t2 - t1 ).TotalMilliseconds;
            //        czasy2[x] = ( t3 - t2 ).TotalMilliseconds;
            //    }
            //    Console.WriteLine( czasy1[0].ToString() );
            //    Console.WriteLine( czasy2.Sum()/1 );
            //}


            {
                using ( var uow = new UnitOfWork() )
                {
                    uow.ConnectionString = ConfigurationManager.AppSettings["ConnectionString"];
                    XPQuery<Ksiazka> ksiazka1 = new XPQuery<Ksiazka>( uow );
                    XPQuery<Egzemplarz> egzemplarz1 = new XPQuery<Egzemplarz>( uow );

                    DateTime t1 = DateTime.Now;

                    foreach ( var c in egzemplarz1 )
                        if ( c.Sygnatura.EndsWith( "5" ) )
                            c.Status++;

                    uow.CommitChanges();
                    DateTime t2 = DateTime.Now;

                    Console.WriteLine( ( t2 - t1 ).TotalMilliseconds.ToString() );
                }
            }

        }
    }
}
